︠02b489ba-df50-4585-9c2c-6668956dda5ci︠
%md
# From Poirier's Bohmian Mechanics without Wavefunctions <br/>To Hall's Many Interacting Worlds#
︡0adc1afb-9c0c-41dc-ae27-3009f56dc118︡{"md":"# From Poirier's Bohmian Mechanics without Wavefunctions <br/>To Hall's Many Interacting Worlds#"}︡
︠73a899c3-9f72-471c-9626-7eb21a725001i︠
%md
Ref:

1. Quantum Phenomena Modeled by Interactions between Many Classical Worlds<br/>
   Michael J. W. Hall Dirk-André Deckert and Howard M. Wiseman,<br/>
   PHYSICAL REVIEW X 4, 041013 (23 October 2014)<br/>
   http://arxiv.org/abs/1402.6144

2. Quantum Mechanics Without Wavefunctions<br/>
   Jeremy Schiff and Bill Poirier<br/>
   J. Chem. Phys. 136, 031102 (2012)<br/>
   http://arxiv.org/abs/1201.2382v1

3. [Verlet integration (Wikipedia)](https://en.wikipedia.org/wiki/Verlet_integration#Velocity_Verlet)<br/><br/>
   ![](https://upload.wikimedia.org/math/f/9/a/f9ab172405a2d7acf403b98a329e2595.png)<br/><br/>
   ![](https://upload.wikimedia.org/math/5/a/5/5a5a4cebe21a1d0f356c29475971698a.png)
︡d89cb504-1dd0-4d7c-8b6d-2c325eb2ecab︡{"md":"Ref:\n\n1. Quantum Phenomena Modeled by Interactions between Many Classical Worlds<br/>\n   Michael J. W. Hall Dirk-André Deckert and Howard M. Wiseman,<br/>\n   PHYSICAL REVIEW X 4, 041013 (23 October 2014)<br/>\n   http://arxiv.org/abs/1402.6144\n\n2. Quantum Mechanics Without Wavefunctions<br/>\n   Jeremy Schiff and Bill Poirier<br/>\n   J. Chem. Phys. 136, 031102 (2012)<br/>\n   http://arxiv.org/abs/1201.2382v1\n\n3. [Verlet integration (Wikipedia)](https://en.wikipedia.org/wiki/Verlet_integration#Velocity_Verlet)<br/><br/>\n   ![](https://upload.wikimedia.org/math/f/9/a/f9ab172405a2d7acf403b98a329e2595.png)<br/><br/>\n   ![](https://upload.wikimedia.org/math/5/a/5/5a5a4cebe21a1d0f356c29475971698a.png)"}︡
︠d2a2d319-dcc1-4c9c-865e-c5939e51eb32︠
%typeset_mode True
from numpy import array, concatenate
from mpmath import erfinv
︡ddda1b2a-65ed-4f38-a09d-e2e6c5b4dcb5︡
︠c5b1d0c1-e4dd-420b-a032-b467dcff9b72i︠
%md
## 1-D ##

Comparison of Poirier's many-D expression to Hall's 1-D "toy" expression.
︡bed90e54-3608-43f6-9294-9c1688fdecc4︡{"md":"## 1-D ##\n\nComparison of Poirier's many-D expression to Hall's 1-D \"toy\" expression."}︡
︠e5ce94ab-7772-486b-b9b6-6c041b1c308e︠
vars= ['x']; d = 1
X = map(function,vars)
# world index
%var n
ind=[n]
# position of particle in world n
P=map(lambda x:x(*ind),X);P
︡a66ef701-f36b-4c01-b41c-2910fc27ce3b︡{"tex":{"tex":"\\left[x\\left(n\\right)\\right]","display":true}}︡
︠440c9ed6-9e4c-454d-91cf-0b697b36b053i︠
%md
### Difference operators ###
For Hall's finite number of interacting worlds we need the following difference operators instead of derivatives.
︡501b519f-030d-4a20-b15a-f05f5bfe492d︡{"md":"### Difference operators ###\nFor Hall's finite number of interacting worlds we need the following difference operators instead of derivatives."}︡
︠e345f303-b094-4f85-9f46-1a8a6b495d95︠
def Dminus(x,i):return(x-x.subs(ind[i]==ind[i]-1))
def Dplus(x,i):return(x.subs(ind[i]==ind[i]+1)-x)
︡20b55ca4-37fa-4b9f-bef2-9bb3e8556c55︡
︠307ec98e-2e3b-4c8d-bea4-454604266b2c︠
Dminus(P[0],0)
Dminus(Dminus(P[0],0),0)
Dplus(Dminus(Dminus(P[0],0),0),0)
Dplus(Dplus(Dminus(Dminus(P[0],0),0),0),0)
︡572dba3d-ea23-4514-aa79-9a30290be35e︡{"tex":{"tex":"-x\\left(n - 1\\right) + x\\left(n\\right)","display":true}}︡{"tex":{"tex":"-2 \\, x\\left(n - 1\\right) + x\\left(n - 2\\right) + x\\left(n\\right)","display":true}}︡{"tex":{"tex":"x\\left(n + 1\\right) + 3 \\, x\\left(n - 1\\right) - x\\left(n - 2\\right) - 3 \\, x\\left(n\\right)","display":true}}︡{"tex":{"tex":"x\\left(n + 2\\right) - 4 \\, x\\left(n + 1\\right) - 4 \\, x\\left(n - 1\\right) + x\\left(n - 2\\right) + 6 \\, x\\left(n\\right)","display":true}}︡
︠b89bed35-4413-4633-b658-0389c589b8c4i︠
%md
etc.

### Hall's "toy" expression ###

eqs. (24,25)
︡105822b1-811b-4ecd-a7e4-b4078993b90f︡{"md":"etc.\n\n### Hall's \"toy\" expression ###\n\neqs. (24,25)"}︡
︠156036e0-12f0-4b41-a22f-f1be2a793262︠
%var hbar,mm
︡e3814d87-e3c9-4c73-bff6-fe494f1d24f9︡
︠34542816-ae87-49e7-bc79-f0e5e17b97c9︠
def sif(n): return(1/((X[0](n))-(X[0](n-1))))
def sigma(n): return((sif(n)^2)*(sif(n+1)-2*sif(n)+sif(n-1)))
def r(n): return(hbar^2/4/mm*(sigma(n+1)-sigma(n)))
def U(n): return(hbar^2/8/mm*(sif(n+1)-sif(n))^2)
︡e5fd36dd-cc69-4619-8206-1fd4d54643f4︡
︠b54f3407-8296-45a5-9252-6c64c9518cf9i︠
%md
### Poirier's expression ###
︡e246f14c-32ca-44d5-b313-c4ec88e5d90d︡{"md":"### Poirier's expression ###"}︡
︠88a3f3c7-ae5c-4046-a2f3-7957e963c1e2︠
# Ensemble of Bohmian trajectories
En = map(lambda x:x(*ind),X);En
# Jacobian: How trajectories change with trajectory index (i.e. as a function of the initial position).
Jn = matrix(map(lambda e:map(lambda c:Dminus(e,c),[i for i in range(d)]),En));Jn
Kn = Jn^(-1);Kn
bool(sif(n)==Kn[0,0])
︡5ddc89aa-caf3-4a31-b6c6-f52ded13cb37︡{"tex":{"tex":"\\left[x\\left(n\\right)\\right]","display":true}}︡{"tex":{"tex":"\\left(\\begin{array}{r}\n-x\\left(n - 1\\right) + x\\left(n\\right)\n\\end{array}\\right)","display":true}}︡{"tex":{"tex":"\\left(\\begin{array}{r}\n-\\frac{1}{x\\left(n - 1\\right) - x\\left(n\\right)}\n\\end{array}\\right)","display":true}}︡{"tex":{"tex":"\\mathrm{True}","display":true}}︡
︠6cd1253d-7028-4750-b694-3ffa7c00911bi︠
%md
### Quantum Force ###

Schiff and Poirier eq. (18)
︡8d54326d-efc2-4849-8291-ad18dcb565c5︡{"md":"### Quantum Force ###\n\nSchiff and Poirier eq. (18)"}︡
︠afce2826-9619-4de7-b54a-2aad439db8fa︠
eq18n = [ sum([ sum([ sum([ sum([
 (hbar^2/4/mm)*Dplus( Kn[k,i]*Kn[p,j]*Dplus( Dminus( Kn[l,j],k ),l ),p )
   for p in range(d)]) for k in range(d)]) for j in range(d)]) for l in range(d)]) for i in range(d)]
eq18n[0]
︡df3aed12-1746-47ae-a32a-cffd22fe564d︡{"tex":{"tex":"\\frac{\\mathit{hbar}^{2} {\\left(\\frac{\\frac{1}{x\\left(n + 2\\right) - x\\left(n + 1\\right)} - \\frac{2}{x\\left(n + 1\\right) - x\\left(n\\right)} - \\frac{1}{x\\left(n - 1\\right) - x\\left(n\\right)}}{{\\left(x\\left(n + 1\\right) - x\\left(n\\right)\\right)}^{2}} - \\frac{\\frac{1}{x\\left(n + 1\\right) - x\\left(n\\right)} + \\frac{1}{x\\left(n - 1\\right) - x\\left(n - 2\\right)} + \\frac{2}{x\\left(n - 1\\right) - x\\left(n\\right)}}{{\\left(x\\left(n - 1\\right) - x\\left(n\\right)\\right)}^{2}}\\right)}}{4 \\, \\mathit{mm}}","display":true}}︡
︠2af534bf-3854-400d-be8e-c80ed91eab1ai︠
%md
Compare to Hall's MIW quantum force
︡c4988509-10ec-4b57-966b-4b73847676e5︡{"md":"Compare to Hall's MIW quantum force"}︡
︠eaff2991-9ee5-4b72-b243-4706abc0ab76︠
bool(eq18n[0]==r(n))
︡b225024a-a8db-44df-8069-07a2873f70ce︡{"tex":{"tex":"\\mathrm{True}","display":true}}︡
︠5750301c-bc41-442b-8db8-3d56ce209142i︠
%md
### Fast Numeric Functions ###
︡b7e75fd1-98d2-4c2a-815d-b4136224aff1︡{"md":"### Fast Numeric Functions ###"}︡
︠21560004-8749-48f8-b0b4-ad2b6bbd30d5i︠
%md Create a numeric function that depends on the nearest neighbors: ```x(n-2) x(n-1) x(n) x(n+1) x(n+2)```
︡784dc6e0-a237-425a-b0de-54646592cf39︡{"md":"Create a numeric function that depends on the nearest neighbors: ```x(n-2) x(n-1) x(n) x(n+1) x(n+2)```"}︡
︠70b92e0c-c7b2-497a-afd8-f22ce8e009c3︠
xsk=[X[i](n+j) for i in range(d) for j in [-2,-1,0,1,2]];xsk
xsv=[var(vars[i]+str(2+j)) for i in range(d) for j in [-2,-1,0,1,2]]; xsv
︡2d23f2b3-f633-423b-96a9-1f871d124087︡{"tex":{"tex":"\\left[x\\left(n - 2\\right), x\\left(n - 1\\right), x\\left(n\\right), x\\left(n + 1\\right), x\\left(n + 2\\right)\\right]","display":true}}︡{"tex":{"tex":"\\left[x_{0}, x_{1}, x_{2}, x_{3}, x_{4}\\right]","display":true}}︡
︠46e7bb49-b616-4f76-badc-c069f2cc6174︠
eq18n3=map(lambda ex: ex.subs(dict(zip(xsk,xsv))),eq18n); eq18n3
︡036aca05-1a8e-4fbb-b385-ae10c28a684d︡{"tex":{"tex":"\\left[\\frac{\\mathit{hbar}^{2} {\\left(\\frac{\\frac{1}{x_{0} - x_{1}} - \\frac{2}{x_{1} - x_{2}} + \\frac{1}{x_{2} - x_{3}}}{{\\left(x_{1} - x_{2}\\right)}^{2}} - \\frac{\\frac{1}{x_{1} - x_{2}} - \\frac{2}{x_{2} - x_{3}} + \\frac{1}{x_{3} - x_{4}}}{{\\left(x_{2} - x_{3}\\right)}^{2}}\\right)}}{4 \\, \\mathit{mm}}\\right]","display":true}}︡
︠e6cba5e7-a412-45ad-8659-5630de15e272︠
rf=fast_callable(eq18n3[0].subs({hbar:2/10,mm:1}), vars=xsv, domain=float)
︡bb6e1f4c-1286-4cd0-82f5-9fa05fee40a0︡
︠94363431-4c29-4877-9745-24074372dc50︠
p1=[random() for i in xsv];p1
︡3e1ff1c4-fc46-41cc-9c09-e6de835e5018︡{"tex":{"tex":"\\left[0.333791178387, 0.000756870815695, 0.458751929544, 0.949630476402, 0.678418378242\\right]","display":true}}︡
︠ad3e87ff-f4b8-4978-94d1-8c2bc4283d3f︠
rf(*p1)
︡75f84836-39d9-4d14-af8f-f91f849fe307︡{"tex":{"tex":"0.0227234023578","display":true}}︡
︠f7806c7c-d879-446f-8d7d-bb445058ff2e︠
%timeit [rf(*p1)]
︡331ba939-4074-41ec-885b-ce13586430bc︡{"stdout":"625 loops, best of 3: 413 ns per loop\n"}︡
︠e672e85a-d5cd-4d3a-b57a-5fd1a0bb4e99i︠
%md
### Quantum Potential###
***Why does Poirier eq. (20) include a second term?***
︡72c5492c-c833-4d5c-a869-43e4d14b55f6︡{"md":"### Quantum Potential###\n***Why does Poirier eq. (20) include a second term?***"}︡
︠a6990bdb-8135-4274-ab59-07e5b963087c︠
eq20n = sum([ sum([ sum([
 (hbar^2/4/mm)*(Kn[k,j]*Dplus( Dplus( Kn[l,j],l ),k )+1/2*Dplus(Kn[l,j],l)*Dplus(Kn[k,j],k))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
eq20n
︡b938f014-301d-4655-80cf-5fc57364836f︡{"tex":{"tex":"\\frac{{\\left({\\left(\\frac{1}{x\\left(n + 1\\right) - x\\left(n\\right)} + \\frac{1}{x\\left(n - 1\\right) - x\\left(n\\right)}\\right)}^{2} - \\frac{2 \\, {\\left(\\frac{1}{x\\left(n + 2\\right) - x\\left(n + 1\\right)} - \\frac{2}{x\\left(n + 1\\right) - x\\left(n\\right)} - \\frac{1}{x\\left(n - 1\\right) - x\\left(n\\right)}\\right)}}{x\\left(n - 1\\right) - x\\left(n\\right)}\\right)} \\mathit{hbar}^{2}}{8 \\, \\mathit{mm}}","display":true}}︡
︠cec00784-4570-4025-8a83-d9931687b103i︠
%md
Only the first term corresponds to Hall's expression.
︡83e38903-d7c0-4020-a9a0-36bf9c490209︡{"md":"Only the first term corresponds to Hall's expression.\n"}︡
︠c974192f-7974-4acf-86b7-c4b4f47c25fe︠
eq20n1 = sum([ sum([ sum([
 (hbar^2/4/mm)*(1/2*Dplus(Kn[l,j],l)*Dplus(Kn[k,j],k))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
eq20n1
︡58fafce4-5b0a-4049-ba0e-3497d9111bba︡{"tex":{"tex":"\\frac{\\mathit{hbar}^{2} {\\left(\\frac{1}{x\\left(n + 1\\right) - x\\left(n\\right)} + \\frac{1}{x\\left(n - 1\\right) - x\\left(n\\right)}\\right)}^{2}}{8 \\, \\mathit{mm}}","display":true}}︡
︠7a95a7fd-c754-4c5e-88fd-f859a74de33a︠
bool(eq20n1==U(n))
︡f83614b4-09ed-4c1b-8f24-72fb6d457b92︡{"tex":{"tex":"\\mathrm{True}","display":true}}︡
︠e5e8a394-279b-4fb2-8af6-581f818a4cf1︠
eq20n3=eq20n.subs(dict(zip(xsk,xsv))); eq20n3
︡644add0f-90ff-425f-8d4d-494c7e0793ec︡{"tex":{"tex":"\\frac{{\\left({\\left(\\frac{1}{x_{1} - x_{2}} - \\frac{1}{x_{2} - x_{3}}\\right)}^{2} + \\frac{2 \\, {\\left(\\frac{1}{x_{1} - x_{2}} - \\frac{2}{x_{2} - x_{3}} + \\frac{1}{x_{3} - x_{4}}\\right)}}{x_{1} - x_{2}}\\right)} \\mathit{hbar}^{2}}{8 \\, \\mathit{mm}}","display":true}}︡
︠454df228-2002-46fe-b6ad-f4814fa1c003︠
ru=fast_callable(eq20n3.subs({hbar:2/10,mm:1}), vars=xsv, domain=float)
︡5ef19314-7cea-4ee4-a958-5bf4671b3b51︡
︠96da717a-5c9f-42de-be8b-a0c1347486cd︠
ru(*p1)
︡bae1a017-0f69-4fcc-98b7-f00ae1187cc7︡{"tex":{"tex":"0.788919852967","display":true}}︡
︠fb6f6edb-b1f7-4118-9199-5bf89afbf6c3i︠
%md
Computation of total energy below shows that Hall's expression is correct.
︡6ac0d30d-34c5-4703-91ac-507aafba2496︡{"md":"Computation of total energy below shows that Hall's expression is correct."}︡
︠a20eed9a-3f19-42cd-a153-b25ec30a5fb7︠
eq20n4=U(n).subs(dict(zip(xsk,xsv))); eq20n4
︡73ed8df6-6ccc-4da7-9a2c-a58e1e96ed0c︡{"tex":{"tex":"\\frac{\\mathit{hbar}^{2} {\\left(\\frac{1}{x_{1} - x_{2}} - \\frac{1}{x_{2} - x_{3}}\\right)}^{2}}{8 \\, \\mathit{mm}}","display":true}}︡
︠c65ffbe0-f3c7-4b59-8e4c-55119b47f639︠
rU=fast_callable(eq20n4.subs({hbar:2/10,mm:1}), vars=xsv, domain=float)
︡b98d9ace-fe44-4ce3-83b1-99924e2ba93d︡
︠3248aeda-d704-4dca-9803-275043a8fc63︠
rU(*p1)
︡4405580b-4cc5-4ea2-913e-9dac52e145ae︡{"tex":{"tex":"3.26673252658","display":true}}︡
︠36e38f1a-c66c-4f62-bcc0-f9b7e1c33d3fi︠
%md
### Classical force ###
︡13cdbb78-a388-4a1b-acb9-85c4beca4247︡{"md":"### Classical force ###"}︡
︠c328f35f-bd3b-4f77-9430-1d4b17463a93︠
a = 0.25
c = 5
#F(x)=((x-c)/(a^3*(3.14)))*exp(-(x-c)^2/a^2)*0.7
F(x)= 9*sech(5*(x-c))^2*tanh(5*(x-c))
︡25b8c877-4c66-4c19-8470-2008b43381e6︡
︠e256b87b-90f2-4d1b-bd72-4cbf7a3e9152︠
FF=fast_callable(F(x), vars=[x], domain=float)
︡eee67011-c43d-4d2c-bddd-534e9edc3b31︡
︠da00e982-d5ed-4c66-ad38-c8eef1ff2f9c︠
plot(FF,(0,10),axes_labels=['location','force'],axes_labels_size=1)
︡fc37ce2e-175a-4c93-95e6-908c301714ab︡{"once":false,"file":{"show":true,"uuid":"b37f4d82-4540-444d-9c4b-31d0c8879e75","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_tba9im.svg"}}︡{"html":"<div align='center'></div>"}︡
︠20be7f40-9278-4a63-8495-16fd8d739382i︠
%md
### Classical potential ###
︡929116b8-9d5a-4440-b6be-648d4edb5ce0︡{"md":"### Classical potential ###"}︡
︠0d5ce662-1e8e-441d-9c2b-1d9daf5086c2︠
#PO=sage_eval("lambda x:"+fricas(-F(x)).integrate(x).simplify().unparsed_input_form());PO(x)
PO(x)=9/(10*cosh(5*x+-5*c)^2)
︡ac7cfc0d-a60a-4944-9cd3-a094671e0cc8︡
︠eb10dcfe-8769-477b-a2ac-1825b17badc8︠
plot(PO,(0,10),axes_labels=['location','energy'],axes_labels_size=1)
︡fc0fe73d-7b58-4540-b136-3d4c5f6b9263︡{"once":false,"file":{"show":true,"uuid":"e82f78d7-94ec-43b2-bc74-6957934d7846","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_juLYrx.svg"}}︡{"html":"<div align='center'></div>"}︡
︠9914649d-582a-4376-9632-ee8f114b51a9i︠
%md
## Simulation ##
Simulation of a single particle in one dimension over 100 worlds. The initial spacial distribution is a Gaussian "wave packet".  The "uniformizing function" is the cummulative distribution, this case the error function.  We can use the inverse of the uniformizing function to create a gaussian packet from a uniform range.

### Initial conditions ###
︡358a118a-da96-491f-a5b6-ca14c44430c0︡{"md":"## Simulation ##\nSimulation of a single particle in one dimension over 100 worlds. The initial spacial distribution is a Gaussian \"wave packet\".  The \"uniformizing function\" is the cummulative distribution, this case the error function.  We can use the inverse of the uniformizing function to create a gaussian packet from a uniform range.\n\n### Initial conditions ###"}︡
︠f5420ca1-15a0-4cd8-9a03-ebe3b0cee5d5︠
N=100
r0=[1.95*i/N for i in range(-N/2,(N+1)/2)]
p0=map(lambda x:float(2.0*erfinv(x)),r0)
︡16ec0f96-62a2-4e17-bffb-4699562e34f5︡
︠1ebe85c3-0b68-4453-beaf-2123f912ec61︠
line2d(zip(r0,p0),axes_labels=['range','location'],axes_labels_size=1)
︡14d7a41f-0c4b-42e6-a914-e9270ebeaf56︡{"once":false,"file":{"show":true,"uuid":"e2f5eda7-abb1-440f-97a0-a88596f3343b","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_XjaIBb.svg"}}︡{"html":"<div align='center'></div>"}︡
︠affe5407-8521-4295-ad9c-46e8a2ed72f8︠
# density
import numpy
def den(p): return map(lambda x:1/x,p[1:]-p[0:N-1])
line2d(zip(p0[1:N],den(array(p0))),axes_labels=['location','density of worlds'],axes_labels_size=1)
︡20a50df2-dea4-4961-86d1-95971e2d797c︡{"once":false,"file":{"show":true,"uuid":"ef545ccf-e276-4502-8161-b8cf663efdfd","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_bVIhyy.svg"}}︡{"html":"<div align='center'></div>"}︡
︠c8aa9d1b-974c-4a61-ac3e-3d644a45d159︠
# initial velocity of particle in each world
v0=[1.2 for i in p0]
︡ac568540-f4e3-4e71-8d79-a3050315e6f4︡
︠a06e5f0c-f888-4c27-96f0-a643b80a96f3i︠
%md
### Acceleration ###
︡b717a520-20e1-469c-8a39-ed8c61804431︡{"md":"### Acceleration ###"}︡
︠48fdffd2-659d-4428-8542-7cc31e587e8f︠
# (quantum force + classical force)/mass
def rf1(X,i):
    global N
    lm2=X[i-2] if i>1 else -(10.0^10)
    lm1=X[i-1] if i>0 else -(10.0^6)
    rp1=X[i+1] if i+1<N else 10.0^6
    rp2=X[i+2] if i+2<N else 10.0^10
    return rf(lm2,lm1,X[i],rp1,rp2)+FF(X[i])
︡f8d50347-aa0c-40e3-82fc-cc92e71f95ca︡
︠59699f9f-0bbc-45aa-8ad1-5193dd2f777c︠
%md Total classical potential
︡114d5c8e-73d9-4db3-80e7-ccb772ada06f︡{"md":"Total classical potential"}︡
︠ccdcaf2f-d5da-44ba-8e2e-8b6943ef443e︠
def PU(x): return sum([PO(x[i]) for i in range(N)])
︡53218a7d-1c3d-4879-9402-08c467548ad9︡
︠173d9f85-2451-447b-9e20-433cadd73e78i︠
%md
Total quantum Potential
︡4352a82c-e566-4390-ba00-7903422a922f︡{"md":"Total quantum Potential"}︡
︠9c014461-6c5d-4aa3-90bc-2fdf8dd0a6db︠
def ru1(X,i):
    global N
    lm2=X[i-2] if i>1 else -(10.0^10)
    lm1=X[i-1] if i>0 else -(10.0^6)
    rp1=X[i+1] if i+1<N else 10.0^6
    rp2=X[i+2] if i+2<N else 10.0^10
    # (quantum potential
    return rU(lm2,lm1,X[i],rp1,rp2)
def QU(x): return sum([ru1(x,i) for i in range(N)])
︡9a2764fc-66aa-4d44-9b68-98c878ea6883︡
︠40fdd742-7574-4263-9dee-330ea20815c3i︠
%md Total kinetic energy
︡6db62615-12b1-414c-aa26-bba6fde614fc︡{"md":"Total kinetic energy"}︡
︠ed7fd577-4fcd-4e57-a783-e96f635d1bb1︠
def K(x): return sum(x^2)/2
︡d7963078-1c4f-4745-861c-ffb8eec14549︡
︠a8ec6254-440f-4721-97c1-0330b8e5da12i︠
%md
## Solution ##
Run the integration

### Velocity Verlet ###

Störmer–Verlet discretization with continuous integrating stepsize controller

Ref:
[Explicit, Time Reversible, Adaptive Step Size Control](http://archive-ouverte.unige.ch/unige:12120)
by Ernst Hairer and Gustaf Söderlind
︡06f49bee-c426-41ea-bfc1-14bd99f4de9a︡{"md":"## Solution ##\nRun the integration\n\n### Velocity Verlet ###\n\nStörmer–Verlet discretization with continuous integrating stepsize controller\n\nRef:\n[Explicit, Time Reversible, Adaptive Step Size Control](http://archive-ouverte.unige.ch/unige:12120)\nby Ernst Hairer and Gustaf Söderlind\n"}︡
︠f07d711d-05fd-43f4-ad93-a514993fb5fd︠
%time
t1 = 10; step = 0.1;
def A(x): return array([rf1(x,i) for i in range(N)])
XX = array(p0)
VV = array(v0)
AX = A(XX)
# minimum step size
ds = 0.002
# controller
def G(p,q): return -alpha*sum(map(prod,zip(p,q)))/sum(map(prod,zip(q,q)))+beta*(1-ds/dt)
alpha = 30.0
beta = 0.5
# step density
rho = 1; dt=ds/rho; rho = rho - G(AX,VV)*dt/2
t = 0
XV = [concatenate((XX,VV))]; tt = [t]
rhos = [rho]
while t<t1:
    # Check total energy conservation
    T1=K(VV)+PU(XX)+QU(XX)
    for i in range(int(step/dt)):
        rho = rho + G(AX,VV)*dt
        dt = ds/rho; t += dt
        XX += VV*dt + AX/2*dt^2
        VV += AX/2*dt; AX = A(XX); VV += AX/2*dt
    T2=K(VV)+PU(XX)+QU(XX)
    if abs(T1-T2)>0.05:
        print "Integration failed at %s."%t,"Try a shorter time step: %s."%ds/2
        break
    XV.append(concatenate((XX,VV))); tt += [t]; rhos.append(rho)
︡d0ccb88c-f6a8-4168-a796-22a1b014a010︡{"stdout":"CPU time: 23.67 s, Wall time: 23.67 s"}︡{"stdout":"\n"}︡
︠402c68b0-9b03-44ba-bad9-dc9db735c0ec︠
len(rhos)
line2d(zip(tt,rhos),axes_labels=['time','rho'],legend_label='step density')
︡fdeb4fe9-e9b9-4b0d-a243-870dcf03b34b︡{"tex":{"tex":"102","display":true}}︡{"once":false,"file":{"show":true,"uuid":"1b76d66d-3135-4edb-985f-5a0eb9c6d068","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp__ZJU5d.svg"}}︡{"html":"<div align='center'></div>"}︡
︠a4360465-6b1e-4131-987e-3a651f153552︠
show(sum([line([[tt[i],XV[i][j]] for i in range(0,len(tt))],rgbcolor = hue(float(j)/N))
  for j in range(N)]),figsize=[10,7],axes_labels=['time','location'],axes_labels_size=1)
︡02f10079-55b0-4b0d-8e93-d4d2d59756df︡{"once":false,"file":{"show":true,"uuid":"ccd3bd1f-9f83-4f06-8c5c-881b42b75924","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_XqR0Wc.svg"}}︡{"html":"<div align='center'></div>"}︡
︠ba744a02-1306-44bf-9560-e5f116939dcb︠
animate([plot(PO,(-5,20),axes_labels=['location','classical potential'],axes_labels_size=1,
  figsize=[10,4]) + text("time:"+("%4.1f"%X[0]).rjust(5), (20,1),color='black') +
  list_plot(zip(X[1][0:N],map(PO,X[1][0:N])), size=15, xmin=-5, xmax=20,ymax=1)
    for X in zip(tt,XV)]).show(gif=true,delay=20)
︡f372f535-ecc5-493d-b7ca-5c0a55887e31︡{"once":false,"file":{"show":true,"uuid":"f025ee08-4e07-4081-ac46-241ddb090fbe","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_cAfkQp.gif"}}︡{"html":"<div align='center'></div>"}︡
︠98fa95db-4522-4331-9e56-9f43e8f14b82︠
animate([line2d(zip(X[1][0:N],den(X[1][0:N])),xmin=-5, xmax=20,ymin=0,ymax=75,
  axes_labels=['location','density'],axes_labels_size=1)+
    text("time:"+("%4.1f"%X[0]).rjust(5), (20,75),color='black')
      for X in zip(tt,XV)]).show(gif=true,delay=20)
︡4542363c-1366-4f3f-b0cd-004b6b11db3b︡{"once":false,"file":{"show":true,"uuid":"69353b35-25c1-4b0d-8e86-ae6523d17ada","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_4q6bpo.gif"}}︡{"html":"<div align='center'></div>"}︡
︠02a3070e-49b3-4291-818e-e2f0d6f7e78f︠
# momentum density
animate([line2d(zip(mu[1],den(mu[1])),xmin=-3,xmax=3,ymin=0,ymax=10^3,
  axes_labels=['velocity','density'],axes_labels_size=1)+
  text("time:"+("%4.1f"%mu[0]).rjust(5), (3,1000),color='black')
  for mu in zip(tt,map(lambda x: x[N:2*N].sort() or x[N:2*N],XV))]).show(gif=true,delay=20)
︡e25c5f74-b149-4722-ae68-e9b62d31617f︡{"stderr":"<string>:1: RuntimeWarning: divide by zero encountered in double_scalars\n"}︡{"once":false,"file":{"show":true,"uuid":"3b297e81-3eeb-4aeb-9db4-0f2b73ec5429","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_sncuMu.gif"}}︡{"html":"<div align='center'></div>"}︡
︠7a53ffe9-76c4-4a41-ad7c-848e4f284bd6i︠
%md
### Velocity ###
︡61d74683-60e8-431c-8520-6d0edf9c3d73︡{"md":"### Velocity ###"}︡
︠7a017ef3-bc5a-44fa-a623-125be79e50f0︠
def average_velocity(t): return sum(map(abs,XV[t][N:2*N]))/N
def num_left(t): return sum(map(lambda x:1 if x<0 else 0,XV[t][N:2*N]))
def average_left(t): return sum(map(lambda x:-x if x<0 else 0,XV[t][N:2*N]))/(0.000001+num_left(t))
def num_right(t): return sum(map(lambda x:1 if x>=0 else 0,XV[t][N:2*N]))
def average_right(t): return sum(map(lambda x: x if x>0 else 0,XV[t][N:2*N]))/(0.000001+num_right(t))
tot=line2d([[tt[i],average_velocity(i)] for i in range(len(tt))],color='blue',legend_label='average',legend_color='blue',ymax=2)
left=line2d([[tt[i],average_left(i)] for i in range(len(tt))],color='red',legend_label='reflection',legend_color='red',ymax=2)
right=line2d([[tt[i],average_right(i)] for i in range(len(tt))],color='green',legend_label='transmission',legend_color='green',ymax=2)
show(tot+left+right,figsize=[9,5],axes_labels=['time','velocity'],axes_labels_size=1)
︡900a9d7d-1f20-44c5-b2ae-a58a7b6e46dc︡{"once":false,"file":{"show":true,"uuid":"354c95f2-ba52-4f79-ba25-2576c7459022","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_FLAFIc.svg"}}︡{"html":"<div align='center'></div>"}︡
︠1139ea81-4e28-4f3f-a56e-ed1dd77dfa01︠
sum(map(abs,XV[len(tt)-1][N:2*N]))-sum(map(abs,XV[0][N:2*N]))
︡ccecc98e-7427-4281-b7a3-62bc5841868a︡{"tex":{"tex":"-19.475570972","display":true}}︡
︠f2ed4f8f-8576-4f0b-a4b8-19b039a3d46ai︠
%md Final state
︡fbf0d63d-3a99-4f95-b0a3-11ef3d456f1b︡{"md":"Final state"}︡
︠bae57916-3700-44ec-b2f5-d24692177bfe︠
print "# of worlds with particles moving left: ", num_left(len(tt)-1), "average velocity: ",average_left(len(tt)-1)
print "# of worlds with particles moving right: ", num_right(len(tt)-1), "average velocity: ",average_right(len(tt)-1)
print "overall average: ",average_velocity(len(tt)-1)
︡3cca4f70-22eb-4e4f-9ead-55fd35a1e34c︡{"stdout":"# of worlds with particles moving left:  60 average velocity:  0.586271573569\n"}︡{"stdout":"# of worlds with particles moving right:  40 average velocity:  1.63370330985\n"}︡{"stdout":"overall average:  1.00524429028\n"}︡
︠9f7a6f41-26c1-4a28-9dec-0460e357e5d9i︠
%md
### Conservation of energy ###
︡44ce86fe-0533-45b3-ae7a-0b1e35e0bb48︡{"md":"### Conservation of energy ###"}︡
︠cb4b2ef4-d664-49c8-b4f7-f6bd499fb64a︠
U1=line2d([[tt[i],QU(XV[i][0:N])] for i in range(len(tt))],
  color='blue',legend_color='blue',legend_label="quantum potential")
U2=line2d([[tt[i],PU(XV[i][0:N])] for i in range(len(tt))],
  color='green', legend_color='green', legend_label="classical potential")
K1=line2d([[tt[i],K(XV[i][N:2*N])] for i in range(len(tt))],
  legend_color='red',color='red',legend_label="kinetic energy")
show(K1+U1+U2,figsize=[9,5],axes_labels=['time','energy'],axes_labels_size=1)
︡54b371fc-aa15-46a2-9994-8a274f5e5883︡{"once":false,"file":{"show":true,"uuid":"f57213b4-8e27-4ad2-aadf-ac5b6cade6e9","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_DQNkWn.svg"}}︡{"html":"<div align='center'></div>"}︡
︠2c282291-7905-43d0-8179-6c5ab694baec︠
line([[tt[i],K(XV[i][N:2*N])+PU(XV[i][0:N])+QU(XV[i][0:N])] for i in range(len(tt))],
  legend_label="total energy",axes_labels=['time','energy'],axes_labels_size=1)
︡1e65f35d-cc5a-453b-8d09-3a6cb725a1d6︡{"once":false,"file":{"show":true,"uuid":"6f54f500-2555-443f-90e7-338214a212af","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/8236/tmp_m4HQ_B.svg"}}︡{"html":"<div align='center'></div>"}︡
︠4cb6b454-11af-46b9-a0af-87554ade4721︠
K(XV[len(tt)-1][N:2*N])+QU(XV[len(tt)-1][0:N])+PU(XV[len(tt)-1][0:N])-K(XV[1][N:2*N])-QU(XV[1][0:N])-PU(XV[1][0:N])

︡ff534d2a-7dcc-4224-a9cc-fb820ef1e0fd︡{"tex":{"tex":"-0.0114684504031","display":true}}︡
︠a600eff4-4efc-43a9-9a50-ba41c1b4a512︠
︡7d6aa83d-1a91-4740-aee3-23fdb2ef5717︡
︠f2f9894f-2b5f-4e23-beea-bfc442f871ac︠









